/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005,2006 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *  t_stddef.h̊JˑilTXNC30pj
 *
 *  ̃CN[ht@ĆCt_stddef.h ̐擪ŃCN[hD
 *  ̃t@C͒ڃCN[h邱Ƃ͂ȂD̃CN[h
 *  t@Cɐ旧ď邽߁C̃CN[ht@CɈˑ
 *  Ă͂ȂȂD
 */

#if !defined( TOPPERS_TOOL_STDDEF_H )
#define TOPPERS_TOOL_STDDEF_H

/*
 *  RpC̊g@\̂߂̃}N`
 */
#define	Inline		_inline
#define	Asm			_asm


/*
 *  ^[Ȃ֐
 */
#define NoReturn


/*
 *  J̕WCN[ht@C̗p
 *
 *  NULL̒`stddef.hCINT_MAXCINT_MINCUINT_MAXCLONG_MAXC
 *  LONG_MINCULONG_MAXCCHAR_BIT̒`limits.h荞ށD
 *
 *  C++/EC++ł́CWdl͂̃CN[ht@Cpӂ
 *  Ƃ͌Ȃ̂ŒӂKvłiقƂǂ̊Jŗpӂ
 *  ĂjD
 */
#ifndef TOPPERS_MACRO_ONLY
#include <stddef.h>
#include <limits.h>
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  stdint.h̑pƂȂ`
 *
 *  Jstdint.hpӂĂ炸Ce^̃TCYp^[
 *  ɓĂ͂܂ꍇɁCstdint.h̑pƂȂ`^D
 *
 *  TOPPERS_STDINT_TYPE1: char/short/int/long long̃rbgꂼ
 *                        8/16/32/64rbgŁC|C^̃rbglong
 *                        ̃rbgƈvꍇ
 */

/*
 *  RpCˑ̃f[^^̒`
 */
#ifndef TOPPERS_MACRO_ONLY

typedef signed char			int8_t;		/* t8rbg */
typedef unsigned char		uint8_t;	/* 8rbg */

typedef signed short		int16_t;	/* t16rbg */
typedef unsigned short		uint16_t;	/* 16rbg */

typedef signed long			int32_t;	/* t32rbg */
typedef unsigned long		uint32_t;	/* 32rbg */

typedef signed long long	int64_t;	/* t64rbg */
typedef unsigned long long	uint64_t;	/* 64rbg */

typedef long				intptr_t;	/* |C^i[ł镄t */
typedef unsigned long		uintptr_t;	/* |C^i[ł镄 */

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  RpCˑ̃f[^^̐萔}N
 */
#ifndef INT8_C
#define INT8_C(val)			(val)
#endif /* INT8_C */

#ifndef UINT8_C
#define UINT8_C(val)		(val ## U)
#endif /* UINT8_C */

#ifndef INT16_C
#define INT16_C(val)		(val)
#endif /* INT16_C */

#ifndef UINT16_C
#define UINT16_C(val)		(val ## U)
#endif /* UINT16_C */

#ifndef INT32_C
#define INT32_C(val)		(val)
#endif /* INT32_C */

#ifndef UINT32_C
#define UINT32_C(val)		(val ## U)
#endif /* UINT32_C */

#ifndef INT64_C
#define INT64_C(val)		(val ## LL)
#endif /* INT64_C */

#ifndef UINT64_C
#define UINT64_C(val)		(val ## ULL)
#endif /* UINT64_C */

/*
 *  RpCˑ̃f[^^Ɋi[łőlƍŏl̒`
 */
#define INT8_MAX			SCHAR_MAX
#define INT8_MIN			SCHAR_MIN
#define UINT8_MAX			UCHAR_MAX

#define INT16_MAX			SHRT_MAX
#define INT16_MIN			SHRT_MIN
#define UINT16_MAX			USHRT_MAX

#define INT32_MAX			LONG_MAX
#define INT32_MIN			LONG_MIN
#define UINT32_MAX			ULONG_MAX

#define INT64_MAX			LLONG_MAX
#define INT64_MIN			LLONG_MIN
#define UINT64_MAX			ULLONG_MAX

/*
 *  _^Ɋւ`
 *
 *  TOPPERS_STDFLOAT_TYPE1: floatIEEE754̒Px_C
 *							double{x_̏ꍇ
 */
#ifdef TOPPERS_STDFLOAT_TYPE1
#ifndef TOPPERS_MACRO_ONLY

typedef float		float32_t;			/* IEEE754̒Px_ */
typedef double		double64_t;			/* IEEE754̔{x_ */

#endif /* TOPPERS_MACRO_ONLY */

#define FLOAT32_MIN		1.17549435e-38F
#define FLOAT32_MAX		3.40282347e+38F
#define DOUBLE64_MIN	2.2250738585072014e-308
#define DOUBLE64_MAX	1.7976931348623157e+308

#endif /* TOPPERS_STDFLOAT_TYPE1 */


/*
 *  󃉃x̒`
 *    shcł͑傫[̔z̓RpCG[ɂȂ邽߁A
 *    ŕʓr`B
 */
#define TOPPERS_EMPTY_LABEL(x,y) x y[1]

#endif /* TOPPERS_TOOL_STDDEF_H */

